// Javascript for proper functioning of the student gradebook
var errorbg = "#F66";
var changedbg = "lightgreen";
var warningbg = "orange";
var defaultbg = "transparent";
var defaulttext = 'Changes are not saved as they are typed. Click "Save" to save them.';

var numscores = <tal:block replace="python: len(view.scores)" />
var scores = new Array(numscores);
scores[0] = '-';
<tal:loop repeat="score view/scores">
     scores[<tal:block replace="python:(repeat['score'].number()*2)-1"/>] = '<tal:block replace="python: view.breakJSString(score.value)"/>';
     scores[<tal:block replace="python:(repeat['score'].number()*2)"/>] = '<tal:block replace="python: view.breakJSString(score.title)"/>';
</tal:loop>

var comps = new Object();
<tal:loop repeat="compgrp view/groups">
     <tal:loop repeat="comp python:view.sortGroupCompetencies(compgrp)">
          comps['<tal:block replace="string: ${repeat/compgrp/number}_${repeat/comp/number}"/>'] = '<tal:block replace="structure python: view.breakJSString(view.context.student.username+'_'+compgrp+'_'+comp.globalId)"/>';
     </tal:loop>
</tal:loop>

var numcomps = 0;
for (var j in comps)
{
 numcomps++;
}
var edited = false;
var currentinput;

function setWarning(text, bg){
    document.getElementById('warningtext').innerHTML = text;
    document.getElementById('warning').style.backgroundColor = bg;
}

function checkValid(e,name){
 edited = true;
 if(e!=null)
 {
    var keynum;
    if(window.event) // IE
    {
    keynum = e.keyCode;
    }
    else if(e.which) // Netscape/Firefox/Opera
    {
    keynum = e.which;
    }
    if ((keynum==13)||(keynum==37)||(keynum==38)||(keynum==39)||(keynum==40) )
    {
        document.getElementsByName(name)[0].select();
        return true;
    }
 }
 var element = document.getElementsByName(name)[0];
 var value = element.value;
 setWarning(defaulttext, defaultbg);
 for(var index in scores){
  if (value==scores[index]) {
   element.style.backgroundColor = changedbg;
   return;} }
 element.style.backgroundColor = warningbg;
 }

function submitEval(){
 setWarning('Checking the form for score validity...', defaultbg);
 var badform = new Boolean(false);
 for (var j in comps) {
     var name = comps[j];
     var element = document.getElementsByName(name)[0];
     var value = element.value;
     var notfound = new Boolean(true);
     for(var k in scores){
	 if (value == scores[k]) {
	     notfound = false;
	     break;
	 }
     }
     if (notfound==true) {
	 element.style.backgroundColor = errorbg;
	 badform = true;
     }
 }
 if (badform==true) {
     setWarning('Some scored entered are invalid. They need to be fixed before submitting.', errorbg);
     return;
 }
 else{document.gradebook.submit();}
}

function spreadsheetBehaviour(e)
{
 var keynum;
 if(window.event) // IE
 {
  keynum = e.keyCode;
 }
 else if(e.which) // Netscape/Firefox/Opera
 {
  keynum = e.which;
 }
 var my_name = currentinput.name;
 var c, done;
 done = new Boolean(false);
 var tempcomps = Array();
 var kk = 0;
 for (var j in comps)
 {
  tempcomps[kk] = comps[j];
  kk++;
 }
 for (c=0;c!=numcomps;c++)
 {
  if (tempcomps[c]==my_name)
   done=true;
  if (done==true)
   break;
 }
 var i_stayed_put = new Boolean(true);
 if (keynum==38) // up arrow
 {
  if (c!=0) {c--; i_stayed_put=false;}
 }
 if ((keynum==40) || (keynum==13)) // down arrow or enter
 {
  if (c!=numcomps-1) {c++; i_stayed_put=false;}
 }
 if (i_stayed_put==true)
  return true;
 var newname = tempcomps[c];
 var el = document.getElementsByName(newname)[0]
 el.focus();
 //el.select();
 return false;
}
