import unittest
import os

from schooltool.testing.functional import collect_ftests
from schooltool.testing.functional import ZCMLLayer

dir = os.path.abspath(os.path.dirname(__file__))
filename = os.path.join(dir, 'ftesting.zcml')

xmlcompetencyio_functional_layer = ZCMLLayer(filename,
                                  __name__,
                                  'xmlcompetencyio_functional_layer')

def test_suite():
    return collect_ftests(filenames=['browser.txt'],
                          layer=xmlcompetencyio_functional_layer)

if __name__ == '__main__':
    unittest.main(defaultTest='test_suite')